/[MITgcm]/MITgcm/tools/genmake2
ViewVC logotype

Diff of /MITgcm/tools/genmake2

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.114 by edhill, Wed Jan 5 22:30:55 2005 UTC revision 1.163 by mlosch, Fri May 25 14:56:36 2007 UTC
# Line 13  Line 13 
13  test_for_package_in_cpp_options() {  test_for_package_in_cpp_options() {
14      cpp_options=$1      cpp_options=$1
15      pkg=$2      pkg=$2
16      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg[ ]"
17      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg[ ]"
18      test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg[ ]"
19      test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg[ ]"
20        test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg$"
21        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg$"
22        test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg$"
23        test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg$"
24  }  }
25    
26  # Search for particular CPP #cmds associated with MPI  # Search for particular CPP #cmds associated with MPI
27  # usage: test_for_mpi_in_cpp_eeoptions CPP_file  # usage: test_for_mpi_in_cpp_eeoptions CPP_file
28  test_for_mpi_in_cpp_eeoptions() {  test_for_mpi_in_cpp_eeoptions() {
29      cpp_options=$1      cpp_options=$1
30      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI[ ]"
31      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI[ ]"
32      test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI[ ]"
33      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI[ ]"
34        test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI$"
35        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI$"
36        test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI$"
37        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI$"
38  }  }
39    
40  # Search for particular string in a file. Return 1 if detected, 0 if not  # Search for particular string in a file. Return 1 if detected, 0 if not
# Line 39  test_for_string_in_file() { Line 47  test_for_string_in_file() {
47      if test "x${RETVAL}" = x0 ; then      if test "x${RETVAL}" = x0 ; then
48          printf "Error: In $file there is an illegal line: "          printf "Error: In $file there is an illegal line: "
49          grep -i "$strng" $file          grep -i "$strng" $file
50          return 1          exit 99
51      fi      fi
52      return 0      return 0
53  }  }
# Line 122  EOF Line 130  EOF
130        stop        stop
131        end        end
132  EOF  EOF
133      test -f Makefile  &&  mv -f Makefile Makefile.bak      test -f $MAKEFILE  &&  mv -f $MAKEFILE $MAKEFILE".tst"
134      cat <<EOF >> Makefile      cat <<EOF >> $MAKEFILE
135  .SUFFIXES:  .SUFFIXES:
136  .SUFFIXES: .$tfs .F  .SUFFIXES: .$tfs .F
137  .F.$tfs:  .F.$tfs:
# Line 148  EOF Line 156  EOF
156              return              return
157          fi          fi
158      fi      fi
159      rm -f genmake_hello.* Makefile      rm -f genmake_hello.* $MAKEFILE
160      test -f Makefile  &&  mv -f Makefile.bak Makefile      test -f $MAKEFILE".tst"  &&  mv -f $MAKEFILE".tst" $MAKEFILE
161    
162      #  If we make it here, use the extensions      #  If we make it here, use the extensions
163      FS=$tfs      FS=$tfs
# Line 181  look_for_makedepend()  { Line 189  look_for_makedepend()  {
189      if test "x${MAKEDEPEND}" = x ; then      if test "x${MAKEDEPEND}" = x ; then
190          which makedepend > /dev/null 2>&1          which makedepend > /dev/null 2>&1
191          RV0=$?          RV0=$?
192            test -f $MAKEFILE  &&  mv -f $MAKEFILE $MAKEFILE".tst"
193            #  echo 'MAKEFILE="'$MAKEFILE'"'
194            cat <<EOF >> $MAKEFILE
195    #   THIS IS A TEST MAKEFILE GENERATED BY "genmake2"
196    #
197    #   Some "makedepend" implementations will die if they cannot
198    #   find a Makefile -- so this file is here to gives them an
199    #   empty one to find and parse.
200    EOF
201          cat <<EOF >> genmake_tc.f          cat <<EOF >> genmake_tc.f
202        program test        program test
203        write(*,*) 'test'        write(*,*) 'test'
# Line 189  look_for_makedepend()  { Line 206  look_for_makedepend()  {
206  EOF  EOF
207          makedepend genmake_tc.f > /dev/null 2>&1          makedepend genmake_tc.f > /dev/null 2>&1
208          RV1=$?          RV1=$?
209            test -f $MAKEFILE  &&  rm -f $MAKEFILE
210            test -f $MAKEFILE".tst"  &&  mv -f $MAKEFILE".tst" $MAKEFILE
211          if test "x${RV0}${RV1}" = x00 ; then          if test "x${RV0}${RV1}" = x00 ; then
212              MAKEDEPEND=makedepend              MAKEDEPEND=makedepend
213          else          else
# Line 237  build_cyrus_makedepend()  { Line 256  build_cyrus_makedepend()  {
256      fi      fi
257  }  }
258    
259    
260    build_embed_encode()
261    {
262        printf "  building the embed-encode utility...  "
263        if test ! -e "$ROOTDIR/tools/embed_encode/encode_files" ; then
264            if test ! -d "$ROOTDIR/tools/embed_encode" ; then
265                echo
266                echo "    Error: can't locate \"$ROOTDIR/tools/embed_encode\""
267                echo
268                EMBED_SRC=f
269                return 1
270            fi
271            clist="cc gcc c89 $CC"
272            for ic in $clist ; do
273                comm="$ic -o encode_files encode_files.c"
274                ( cd $ROOTDIR/tools/embed_encode && $comm ) > /dev/null 2>&1
275                RETVAL=$?
276                if test "x$RETVAL" = x0 ; then
277                    echo "OK"
278                    DEFINES="$DEFINES -DHAVE_EMBED_SRC"
279                    return 0
280                fi
281            done
282            echo
283            echo "    Error: unable to build $ROOTDIR/embed_encode/encode_files"
284            echo "      so it has been disabled"
285            echo
286            EMBED_SRC=f
287            return 1
288        fi
289        echo "OK"
290        DEFINES="$DEFINES -DHAVE_EMBED_SRC"
291    }
292    
293    
294  # Guess possible config options for this host  # Guess possible config options for this host
295  find_possible_configs()  {  find_possible_configs()  {
296    
# Line 271  find_possible_configs()  { Line 325  find_possible_configs()  {
325    
326      #================================================================      #================================================================
327      #  look for possible C compilers      #  look for possible C compilers
328      tmp="$MITGCM_CC $CC gcc c89 cc c99 mpicc"      tmp="$MITGCM_CC $CC gcc c89 cc c99 mpicc icc"
329      p_CC=      p_CC=
330      for c in $tmp ; do      for c in $tmp ; do
331          rm -f ./genmake_hello.c  ./genmake_hello          rm -f ./genmake_hello.c  ./genmake_hello
# Line 310  EOF Line 364  EOF
364    
365      #================================================================      #================================================================
366      #  look for possible FORTRAN compilers      #  look for possible FORTRAN compilers
367      tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95"      tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc ifort f90 f95 mpif77 mpf77 mpxlf95 gfortran g95"
368      p_FC=      p_FC=
369      for c in $tmp ; do      for c in $tmp ; do
370          rm -f ./hello.f ./hello          rm -f ./hello.f ./hello
# Line 342  EOF Line 396  EOF
396      else      else
397          echo "  The possible FORTRAN compilers found in your path are:"          echo "  The possible FORTRAN compilers found in your path are:"
398          echo "   "$p_FC          echo "   "$p_FC
399          if test "x$FC" = x ; then      fi
400              FC=`echo $p_FC | $AWK '{print $1}'`  
401              echo "  Setting FORTRAN compiler to: "$FC      #  Use the first of the compilers found in the current PATH
402          fi      #  that has a correctly-named optfile
403        if test "x$OPTFILE" = x  -a  "x$FC" = x ; then
404            for i in $p_FC ; do
405                OPTFILE=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$i
406                if test -r $OPTFILE ; then
407                    echo "  Setting OPTFILE to: "$OPTFILE
408                    break
409                fi
410            done
411      fi      fi
412    
413      if test "x$OPTFILE" = x ; then      if test "x$OPTFILE" = x ; then
# Line 516  Usage: "$0" [OPTIONS] Line 578  Usage: "$0" [OPTIONS]
578            *only* works if it is supported by the OPTFILE that            *only* works if it is supported by the OPTFILE that
579            is being used.            is being used.
580    
581        -ignoretime | -ignore_time | --ignoretime | --ignore_time
582              Ignore all the "wall clock" routines entirely.  This will
583              not in any way hurt the model results -- it simply means
584              that the code that checks how long the model spends in
585              various routines will give junk values.
586    
587        -ts | --ts
588              Produce timing information per timestep
589        -papis | --papis
590              Produce summary MFlop/s (and IPC) with PAPI per timestep
591        -pcls | --pcls
592              Produce summary MFlop/s etc. with PCL per timestep
593        -foolad | --foolad
594              Fool the AD code generator
595        -papi | --papi
596              Performance analysis with PAPI
597        -pcl | --pcl
598              Performance analysis with PCL
599        -hpmt | --hpmt
600              Performance analysis with the HPM Toolkit
601    
602        -gsl | --gsl
603              Use GSL to control floating point rounding and precision
604        -devel | --devel
605              Add additional warning and debugging flags for development
606    
607      -mpi | --mpi      -mpi | --mpi
608            Include MPI header files and link to MPI libraries            Include MPI header files and link to MPI libraries
609      -mpi=PATH | --mpi=PATH      -mpi=PATH | --mpi=PATH
# Line 523  Usage: "$0" [OPTIONS] Line 611  Usage: "$0" [OPTIONS]
611            set to PATH. i.e. Include files from \$PATH/include, link to libraries            set to PATH. i.e. Include files from \$PATH/include, link to libraries
612            from \$PATH/lib and use binaries from \$PATH/bin.            from \$PATH/lib and use binaries from \$PATH/bin.
613    
614        -es | --es | -embed-source | --embed-source
615              Embed a tarball containing the full source code
616              (including the Makefile, etc.) used to build the
617              executable [off by default]
618    
619      -bash NAME      -bash NAME
620            Explicitly specify the Bourne or BASH shell to use            Explicitly specify the Bourne or BASH shell to use
621    
# Line 581  WARNING: Please contact <MITgcm-support@ Line 674  WARNING: Please contact <MITgcm-support@
674  EOF  EOF
675          return 1          return 1
676      fi      fi
677      cat > genmake_tcomp.f <<EOF      cat > genmake_tcomp.$FS <<EOF
678        subroutine tcall( string )        subroutine tcall( string )
679        character*(*) string        character*(*) string
680        call tsub( string )        call tsub( string )
681        end        end
682  EOF  EOF
683      $FC $FFLAGS $DEFINES -c genmake_tcomp.f >> genmake_warnings 2>&1      $FC $FFLAGS -c genmake_tcomp.$FS >> genmake_warnings 2>&1
684      RETVAL=$?      RETVAL=$?
685      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
686          FC_NAMEMANGLE=$default_nm          FC_NAMEMANGLE=$default_nm
# Line 653  void FC_NAMEMANGLE(cloc) ( double *curti Line 746  void FC_NAMEMANGLE(cloc) ( double *curti
746   *curtim = *curtim/1.E6;   *curtim = *curtim/1.E6;
747  }  }
748  EOF  EOF
749      make genmake_tc_1.o >> genmake_tc.log 2>&1      make genmake_tc_1.o >> genmake_warnings 2>&1
750      RET_C=$?      RET_C=$?
751      cat <<EOF > genmake_tc_2.f      cat <<EOF > genmake_tc_2.$FS
752        program hello        program hello
753        Real*8 wtime        REAL*8 wtime
754        external cloc        external cloc
755        call cloc(wtime)        call cloc(wtime)
756        print *," HELLO WORLD", wtime        print *," HELLO WORLD", wtime
757        end program hello        end
758  EOF  EOF
759      $FC $FFLAGS -o genmake_tc genmake_tc_2.f genmake_tc_1.o >> genmake_tc.log 2>&1      COMM="$FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o"
760        echo $COMM >> genmake_warnings
761        $COMM >> genmake_warnings 2>&1
762      RET_F=$?      RET_F=$?
763      test -x ./genmake_tc  &&  ./genmake_tc >> genmake_tc.log 2>&1      test -x ./genmake_tc  &&  ./genmake_tc >> genmake_warnings 2>&1
764      RETVAL=$?      RETVAL=$?
765      if test "x$RETVAL" = x0 ; then      if test "x$RETVAL" = x0 ; then
766          HAVE_CLOC=t          HAVE_CLOC=t
# Line 675  EOF Line 770  EOF
770  }  }
771    
772    
773    check_HAVE_SIGREG()  {
774        if test ! "x$HAVE_SIGREG" = x ; then
775            return
776        fi
777        get_fortran_c_namemangling
778        cat <<EOF > genmake_tc_1.c
779    $FC_NAMEMANGLE
780    #include <stdlib.h>
781    #include <stdio.h>
782    #include <signal.h>
783    #include <errno.h>
784    #include <ucontext.h>
785    
786    int * ip;
787    
788    static void killhandler(
789        unsigned int sn, siginfo_t  si, struct ucontext *sc )
790    {
791        *ip = *ip + 1;
792        return;
793    }
794    
795    void FC_NAMEMANGLE(sigreg) (int * aip)
796    {
797        struct sigaction s;
798        ip = aip;
799        s.sa_flags = SA_SIGINFO;
800        s.sa_sigaction = (void *)killhandler;
801        if(sigaction (SIGTERM,&s,(struct sigaction *)NULL)) {
802            printf("Sigaction returned error = %d\n", errno);
803            exit(0);
804        }
805        return;
806    }
807    EOF
808        make genmake_tc_1.o >> genmake_warnings 2>&1
809        RET_C=$?
810        cat <<EOF > genmake_tc_2.$FS
811          program hello
812          integer anint
813          common /iv/ anint
814          external sigreg
815          call sigreg(anint)
816          end
817    EOF
818        echo >> genmake_warnings
819        echo "running: check_HAVE_SIGREG()" >> genmake_warnings
820        cat genmake_tc_2.$FS >> genmake_warnings
821        COMM="$FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o"
822        echo $COMM >> genmake_warnings
823        $COMM >> genmake_warnings 2>&1
824        RETVAL=$?
825        if test "x$RETVAL" = x0 ; then
826            HAVE_SIGREG=t
827            DEFINES="$DEFINES -DHAVE_SIGREG"
828        fi
829        rm -f genmake_tc*
830    }
831    
832    
833    check_HAVE_SETRLSTK()  {
834        if test "x$HAVE_SETRLSTK" = xt ; then
835            DEFINES="$DEFINES -DHAVE_SETRLSTK"
836            return
837        fi  
838        if test ! "x$HAVE_SETRLSTK" = x ; then
839            return
840        fi
841        get_fortran_c_namemangling
842        cat <<EOF > genmake_tc_1.c
843    $FC_NAMEMANGLE
844    #include <sys/time.h>
845    #include <sys/resource.h>
846    #include <unistd.h>
847    void FC_NAMEMANGLE(setrlstk) ()
848    {
849        struct rlimit rls;
850        rls.rlim_cur = RLIM_INFINITY;
851        rls.rlim_max = RLIM_INFINITY;
852        setrlimit(RLIMIT_STACK, &rls);
853        return;
854    }
855    EOF
856        make genmake_tc_1.o >> genmake_warnings 2>&1
857        RET_C=$?
858        cat <<EOF > genmake_tc_2.$FS
859          program hello
860          external setrlstk
861          call setrlstk()
862          end
863    EOF
864        echo >> genmake_warnings
865        echo "running: check_HAVE_SETRLSTK()" >> genmake_warnings
866        cat genmake_tc_2.$FS >> genmake_warnings
867        COMM="$FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o"
868        echo $COMM >> genmake_warnings
869        $COMM >> genmake_warnings 2>&1
870        RETVAL=$?
871        if test "x$RETVAL" = x0 ; then
872            HAVE_SETRLSTK=t
873            DEFINES="$DEFINES -DHAVE_SETRLSTK"
874        fi
875        rm -f genmake_tc*
876    }
877    
878    
879  check_HAVE_STAT()  {  check_HAVE_STAT()  {
880      get_fortran_c_namemangling      get_fortran_c_namemangling
881      cat <<EOF > genmake_tc_1.c      cat <<EOF > genmake_tc_1.c
# Line 698  void FC_NAMEMANGLE(tfsize) ( int *nbyte Line 899  void FC_NAMEMANGLE(tfsize) ( int *nbyte
899  EOF  EOF
900      make genmake_tc_1.o >> genmake_tc.log 2>&1      make genmake_tc_1.o >> genmake_tc.log 2>&1
901      RET_C=$?      RET_C=$?
902      cat <<EOF > genmake_tc_2.f      cat <<EOF > genmake_tc_2.$FS
903        program hello        program hello
904        integer nbyte        integer nbyte
905        call tfsize(nbyte)        call tfsize(nbyte)
906        print *," HELLO WORLD", nbyte        print *," HELLO WORLD", nbyte
907        end program hello        end
908  EOF  EOF
909      $FC $FFLAGS -o genmake_tc genmake_tc_2.f genmake_tc_1.o >> genmake_tc.log 2>&1      echo >> genmake_warnings
910      RET_F=$?      echo "running: check_HAVE_STAT()" >> genmake_warnings
911      test -x ./genmake_tc  &&  ./genmake_tc >> genmake_tc.log 2>&1      cat genmake_tc_2.$FS >> genmake_warnings
912        COMM="$FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o"
913        echo $COMM >> genmake_warnings
914        $COMM >> genmake_tc.log 2>&1
915      RETVAL=$?      RETVAL=$?
916      if test "x$RETVAL" = x0 ; then      if test "x$RETVAL" = x0 ; then
917          HAVE_STAT=t          HAVE_STAT=t
# Line 721  check_netcdf_libs()  { Line 925  check_netcdf_libs()  {
925      if test ! "x$SKIP_NETCDF_CHECK" = x ; then      if test ! "x$SKIP_NETCDF_CHECK" = x ; then
926          return          return
927      fi      fi
928      echo "" > genmake_tnc.log      echo >> genmake_warnings
929      cat <<EOF > genmake_tnc.for      echo "running: check_netcdf_libs()" >> genmake_warnings
930        cat <<EOF > genmake_tnc.F
931        program fgennc        program fgennc
932  #include "netcdf.inc"  #include "netcdf.inc"
933  EOF  EOF
934      if test ! "x$MPI" = x ; then      if test ! "x$MPI" = x ; then
935          echo '#include "mpif.h"' >> genmake_tnc.for          echo '#include "mpif.h"' >> genmake_tnc.F
936      fi      fi
937      cat <<EOF >> genmake_tnc.for      cat <<EOF >> genmake_tnc.F
938        integer iret, ncid, xid        integer iret, ncid, xid
939        iret = nf_create('genmake_tnc.nc', NF_CLOBBER, ncid)        iret = nf_create('genmake_tnc.nc', NF_CLOBBER, ncid)
940        IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)        IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
# Line 739  EOF Line 944  EOF
944        IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)        IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
945        end        end
946  EOF  EOF
947      echo "Executing:" > genmake_tnc.log      echo "===  genmake_tnc.F  ===" > genmake_tnc.log
948      echo "  $CPP $DEFINES $INCLUDES genmake_tnc.for > genmake_tnc.f" \      cat genmake_tnc.F >> genmake_tnc.log
949          > genmake_tnc.log      echo "===  genmake_tnc.F  ===" >> genmake_tnc.log
950      RET_CPP=f      RET_CPP=f
951      $CPP $DEFINES $INCLUDES genmake_tnc.for > genmake_tnc.f 2>/dev/null  \      COMM="cat genmake_tnc.F | $CPP $DEFINES $INCLUDES"
952          &&  RET_CPP=t      echo "$COMM" >> genmake_tnc.log
953        eval $COMM > genmake_tnc.$FS 2>/dev/null  &&  RET_CPP=t
954      if test "x$RET_CPP" = xf ; then      if test "x$RET_CPP" = xf ; then
955          echo "  WARNING: CPP failed to pre-process the netcdf test." \          echo "  WARNING: CPP failed to pre-process the netcdf test." \
956              > genmake_tnc.log              >> genmake_tnc.log
957          echo "    Please check that \$INCLUDES is properly set." \          echo "    Please check that \$INCLUDES is properly set." \
958              > genmake_tnc.log              >> genmake_tnc.log
959      fi      fi
960      echo "Executing:" > genmake_tnc.log      echo "$FC $FFLAGS $FOPTIM -c genmake_tnc.$FS  \ " >> genmake_tnc.log
961      echo "  $FC $FFLAGS $FOPTIM -c genmake_tnc.f" > genmake_tnc.log      echo "  &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc.o $LIBS" >> genmake_tnc.log
962      echo "  $LINK -o genmake_tnc.o $LIBS" > genmake_tnc.log      $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \
963      $FC $FFLAGS $FOPTIM -c genmake_tnc.f >> genmake_tnc.log 2>&1  \          &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS >> genmake_tnc.log 2>&1
         &&  $LINK -o genmake_tnc genmake_tnc.o $LIBS >> genmake_tnc.log 2>&1  
964      RET_COMPILE=$?      RET_COMPILE=$?
965        cat genmake_tnc.log >> genmake_warnings
966    
967      #EH3  Remove test program execution for machines that either disallow      #EH3  Remove test program execution for machines that either disallow
968      #EH3  execution or cannot support it (eg. cross-compilers)      #EH3  execution or cannot support it (eg. cross-compilers)
# Line 769  EOF Line 975  EOF
975          HAVE_NETCDF=t          HAVE_NETCDF=t
976      else      else
977          # try again with "-lnetcdf" added to the libs          # try again with "-lnetcdf" added to the libs
978          $CPP $DEFINES $INCLUDES genmake_tnc.for > genmake_tnc.f 2>/dev/null  \          echo "try again with added '-lnetcdf'" > genmake_tnc.log
979              &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.f >> genmake_tnc.log 2>&1  \          echo "cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS \ " >> genmake_tnc.log
980              &&  $LINK -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf >> genmake_tnc.log 2>&1          echo " &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS \ " >> genmake_tnc.log
981            echo " &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf" >> genmake_tnc.log
982            cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS 2>/dev/null  \
983                &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \
984                &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf >> genmake_tnc.log 2>&1
985          RET_COMPILE=$?          RET_COMPILE=$?
986            cat genmake_tnc.log >> genmake_warnings
987          if test "x$RET_COMPILE" = x0 ; then          if test "x$RET_COMPILE" = x0 ; then
988              LIBS="$LIBS -lnetcdf"              LIBS="$LIBS -lnetcdf"
989              HAVE_NETCDF=t              HAVE_NETCDF=t
990          else          else
991            # try again with "-lnetcdff" added to the libs
992                echo "try again with added '-lnetcdff -lnetcdf'" > genmake_tnc.log
993                echo "cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS \ " >> genmake_tnc.log
994                echo " &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS \ " >> genmake_tnc.log
995                echo " &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf" >> genmake_tnc.log
996                cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS 2>/dev/null  \
997                    &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \
998                    &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdff -lnetcdf >> genmake_tnc.log 2>&1
999                RET_COMPILE=$?
1000              cat genmake_tnc.log >> genmake_warnings              cat genmake_tnc.log >> genmake_warnings
1001                if test "x$RET_COMPILE" = x0 ; then
1002                    LIBS="$LIBS -lnetcdff -lnetcdf"
1003                    HAVE_NETCDF=t
1004                fi
1005          fi          fi
1006      fi      fi
1007      rm -f genmake_tnc*      rm -f genmake_tnc*
# Line 804  DEFINES= Line 1028  DEFINES=
1028  PACKAGES=  PACKAGES=
1029  ENABLE=  ENABLE=
1030  DISABLE=  DISABLE=
1031  MAKEFILE=  # MAKEFILE=
1032  #MAKEDEPEND=  # MAKEDEPEND=
1033  PDEPEND=  PDEPEND=
1034  DUMPSTATE=t  DUMPSTATE=t
1035  PDEFAULT=  PDEFAULT=
# Line 823  NOOPTFILES= Line 1047  NOOPTFILES=
1047  NOOPTFLAGS=  NOOPTFLAGS=
1048  MPI=  MPI=
1049  MPIPATH=  MPIPATH=
1050    TS=
1051    PAPIS=
1052    PCLS=
1053    FOOLAD=
1054    PAPI=
1055    PCL=
1056    HPMT=
1057    GSL=
1058    DEVEL=
1059    HAVE_TEST_L=
1060    
1061  # DEFINES checked by test compilation  # DEFINES checked by test compilation or command-line
1062  HAVE_SYSTEM=  HAVE_SYSTEM=
1063  HAVE_FDATE=  HAVE_FDATE=
1064  FC_NAMEMANGLE=  FC_NAMEMANGLE=
1065  HAVE_CLOC=  HAVE_CLOC=
1066    # HAVE_SETRLSTK=
1067  HAVE_STAT=  HAVE_STAT=
1068  HAVE_NETCDF=  HAVE_NETCDF=
1069  HAVE_ETIME=  HAVE_ETIME=
1070    IGNORE_TIME=
1071    
1072  MODS=  MODS=
1073  TOOLSDIR=  TOOLSDIR=
# Line 844  BASH= Line 1080  BASH=
1080  PWD=`pwd`  PWD=`pwd`
1081  test "x$MAKE" = x  &&  MAKE=make  test "x$MAKE" = x  &&  MAKE=make
1082  test "x$AWK" = x   &&  AWK=awk  test "x$AWK" = x   &&  AWK=awk
1083    EMBED_SRC=
1084  THISHOST=`hostname`  THISHOST=`hostname`
1085  THISCWD=`pwd`  THISCWD=`pwd`
1086  THISDATE=`date`  THISDATE=`date`
# Line 877  TAMC_EXTRA= Line 1114  TAMC_EXTRA=
1114    
1115  #  The following state can be set directly by command-line switches  #  The following state can be set directly by command-line switches
1116  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"
1117  gm_s2="FC CPP IEEE MPI JAM DUMPSTATE STANDARDDIRS"  gm_s2="FC CPP IEEE TS PAPIS PCLS PAPI PCL HPMT GSL DEVEL MPI JAM DUMPSTATE STANDARDDIRS"
1118    
1119  #  The following state is not directly set by command-line switches  #  The following state is not directly set by command-line switches
1120  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "
# Line 1057  for ac_option in "$@" ; do Line 1294  for ac_option in "$@" ; do
1294          -noieee | --noieee)          -noieee | --noieee)
1295              IEEE= ;;              IEEE= ;;
1296    
1297            -ts | --ts)
1298                TS=true ;;
1299            -papis | --papis)
1300                PAPIS=true ;;
1301            -pcls | --pcls)
1302                PCLS=true ;;
1303            -foolad | --foolad)
1304                FOOLAD=true ;;
1305            -papi | --papi)
1306                PAPI=true ;;
1307            -pcl | --pcl)
1308                PCL=true ;;
1309            -hpmt | --hpmt)
1310                HPMT=true ;;
1311    
1312            -gsl | --gsl)
1313                GSL=true ;;
1314    
1315            -devel | --devel)
1316                DEVEL=true ;;
1317    
1318          -mpi | --mpi)          -mpi | --mpi)
1319              MPI=true ;;              MPI=true ;;
1320          -mpi=* | --mpi=*)          -mpi=* | --mpi=*)
# Line 1080  for ac_option in "$@" ; do Line 1338  for ac_option in "$@" ; do
1338              ac_prev=TAMC_EXTRA ;;              ac_prev=TAMC_EXTRA ;;
1339          -tamc_extra=* | --tamc_extra=*)          -tamc_extra=* | --tamc_extra=*)
1340              TAMC_EXTRA=$ac_optarg ;;              TAMC_EXTRA=$ac_optarg ;;
1341            
1342            -ignoretime | -ignore_time | --ignoretime | --ignore_time)
1343                IGNORE_TIME="-DIGNORE_TIME" ;;
1344    
1345            -es | --es | -embed-source | --embed-source)
1346                EMBED_SRC=t ;;
1347    
1348          -*)          -*)
1349              echo "Error: unrecognized option: "$ac_option              echo "Error: unrecognized option: "$ac_option
# Line 1095  for ac_option in "$@" ; do Line 1359  for ac_option in "$@" ; do
1359            
1360  done  done
1361    
1362    
1363  if test -f ./.genmakerc ; then  if test -f ./.genmakerc ; then
1364      echo      echo
1365      echo "WARNING: genmake2 has detected a copy of the old-style \"./.genmakerc\""      echo "WARNING: genmake2 has detected a copy of the old-style \"./.genmakerc\""
1366      echo "  file.  This file format is no longer supported.  Please see:"      echo "  file.  This file format is no longer supported.  For directions on"
1367      echo      echo "  how to setup and use the new \"genmake2\" script, please see:"
1368      echo "    http://mitgcm.org/devel_HOWTO/"      echo "    http://mitgcm.org/devel_HOWTO/"
1369      echo      echo "  and send an email to MITgcm-support@mitgcm.org if you need help."
1370      echo "  for directions on how to setup and use the new \"genmake2\" input"      echo "WARNING: ignore \"./.genmakerc\" and continue."
     echo "  files and send an email to MITgcm-support@mitgcm.org if you want help."  
1371      echo      echo
1372  fi  fi
1373    
1374  #  Find the MITgcm ${ROOTDIR}  #  Find the MITgcm ${ROOTDIR}
1375  if test "x${ROOTDIR}" = x ; then  if test "x${ROOTDIR}" = x ; then
1376      tmp=`echo $PWD | sed -e 's/\// /g' | $AWK '{print $NR}'`      tmp=`echo $PWD | sed -e 's/\// /g' | $AWK '{print $NR}'`
1377      if test "x$tmp" = "xbin" -a -d ../model -a -d ../eesup -a -d ../pkg ; then      if test "x$tmp" = "xbin" -a -d ../model -a -d ../eesupp -a -d ../pkg ; then
1378          ROOTDIR=".."          ROOTDIR=".."
1379      else      else
1380          for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do          for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do
# Line 1136  fi Line 1400  fi
1400    
1401  #  Find the MITgcm ${THISVER}  #  Find the MITgcm ${THISVER}
1402  if test -f "${ROOTDIR}/doc/tag-index" ; then  if test -f "${ROOTDIR}/doc/tag-index" ; then
1403      THISVER=`grep checkpoint ${ROOTDIR}/doc/tag-index | head -1`      THISVER=`grep '^checkpoint' ${ROOTDIR}/doc/tag-index | head -1`
1404    fi
1405    
1406    if test "x$MAKEFILE" = x ; then
1407        MAKEFILE="Makefile"
1408  fi  fi
1409    
1410  echo "  getting OPTFILE information:  "  echo "  getting OPTFILE information:  "
# Line 1168  if test "x$OPTFILE" != xNONE ; then Line 1436  if test "x$OPTFILE" != xNONE ; then
1436      fi      fi
1437  fi  fi
1438    
 #  Check for broken systems that cannot correctly distinguish *.F and *.f files  
 # check_for_broken_Ff  
   
1439  echo "  getting AD_OPTFILE information:  "  echo "  getting AD_OPTFILE information:  "
1440  if test "x${AD_OPTFILE}" = x ; then  if test "x${AD_OPTFILE}" = x ; then
1441      if test "x$MITGCM_AD_OF" = x ; then      if test "x$MITGCM_AD_OF" = x ; then
# Line 1198  if test "x${AD_OPTFILE}" != xNONE ; then Line 1463  if test "x${AD_OPTFILE}" != xNONE ; then
1463      fi      fi
1464  fi  fi
1465    
1466    #====================================================================
1467    #  Set default values if not set by the optfile
1468    #
1469  #  Check that FC, CC, LINK, CPP, S64, LN, and MAKE are defined.  If not,  #  Check that FC, CC, LINK, CPP, S64, LN, and MAKE are defined.  If not,
1470  #  either set defaults or complain and abort!  #  either set defaults or complain and abort!
1471  if test ! "x$BASH" = x ; then  if test ! "x$BASH" = x ; then
# Line 1274  Error: The command "ln -s" failed -- ple Line 1542  Error: The command "ln -s" failed -- ple
1542  EOF  EOF
1543      exit 1      exit 1
1544  fi  fi
1545    test -L genmake_tlink > /dev/null 2>&1
1546    RETVAL=$?
1547    if test "x$RETVAL" = x0 ; then
1548        HAVE_TEST_L=t
1549    fi
1550  rm -f genmake_test_ln genmake_tlink  rm -f genmake_test_ln genmake_tlink
1551    
1552  #  Check for broken *.F/*.f handling and fix if possible  #  Check for broken *.F/*.f handling and fix if possible
# Line 1284  if test ! "x$MPI" = x ; then Line 1557  if test ! "x$MPI" = x ; then
1557        DEFINES="$DEFINES -DALLOW_USE_MPI -DALWAYS_USE_MPI"        DEFINES="$DEFINES -DALLOW_USE_MPI -DALWAYS_USE_MPI"
1558  fi  fi
1559    
1560    if test ! "x$TS" = x ; then
1561          echo "  Turning on timing per timestep"
1562          if test ! "x$FOOLAD" = x ; then
1563                DEFINES="$DEFINES -DTIME_PER_TIMESTEP_SFP"
1564          else
1565                DEFINES="$DEFINES -DTIME_PER_TIMESTEP"
1566          fi
1567    fi
1568    if test ! "x$PAPIS" = x ; then
1569          echo "  Turning on PAPI flop summary per timestep"
1570          echo "  Please make sure PAPIINC, PAPILIB are defined"
1571          if test ! "x$FOOLAD" = x ; then
1572                DEFINES="$DEFINES -DUSE_PAPI_FLOPS_SFP"
1573          else
1574                DEFINES="$DEFINES -DUSE_PAPI_FLOPS"
1575          fi
1576          INCLUDES="$INCLUDES $PAPIINC"
1577          LIBS="$LIBS $PAPILIB"
1578    fi
1579    if test ! "x$PCLS" = x ; then
1580          echo "  Turning on PCL counter summary per timestep"
1581          echo "  Please make sure PCLINC, PCLLIB are defined"
1582          if test ! "x$FOOLAD" = x ; then
1583                DEFINES="$DEFINES -DUSE_PCL_FLOPS_SFP"
1584          else
1585                DEFINES="$DEFINES -DUSE_PCL_FLOPS"
1586          fi
1587          INCLUDES="$INCLUDES $PCLINC"
1588          LIBS="$LIBS $PCLLIB"
1589    fi
1590    if test ! "x$PAPI" = x ; then
1591          if test ! "x$PAPIS" = x ; then
1592              echo "  PAPI performance analysis and flop summary per timestep cannot co-exist!"
1593              echo "  Sticking with PAPI flop summary per timestep!"
1594          else
1595              echo "  Turning on performance analysis with PAPI"
1596              echo "  Please make sure PAPIINC, PAPILIB are defined"
1597              DEFINES="$DEFINES -DUSE_PAPI"
1598              INCLUDES="$INCLUDES $PAPIINC"
1599              LIBS="$LIBS $PAPILIB"
1600          fi
1601    fi
1602    if test ! "x$PCL" = x ; then
1603          if test ! "x$PCLS" = x ; then
1604              echo "  PCL performance analysis and flop summary per timestep cannot co-exist!"
1605              echo "  Sticking with PCL flop summary per timestep!"
1606          else
1607              echo "  Turning on performance analysis with PCL"
1608              echo "  Please make sure PCLINC, PCLLIB are defined"
1609              DEFINES="$DEFINES -DUSE_PCL"
1610              INCLUDES="$INCLUDES $PCLINC"
1611              LIBS="$LIBS $PCLLIB"
1612          fi
1613    fi
1614    if test ! "x$HPMT" = x ; then
1615          if test ! "x$PAPI" = x ; then
1616              echo "  PAPI and the HPM Toolkit cannot co-exist!"
1617              echo "  Sticking with PAPI!"
1618          else if test ! "x$PCL" = x ; then
1619              echo "  PCL and the HPM Toolkit cannot co-exist!"
1620              echo "  Sticking with PCL!"
1621          else
1622              echo "  Turning on performance analysis with the HPM Toolkit"
1623              echo "  Please make sure HPMTINC, HPMTLIB are defined"
1624              DEFINES="$DEFINES -DUSE_LIBHPM"
1625              INCLUDES="$INCLUDES $HPMTINC"
1626              LIBS="$LIBS $HPMTLIB"
1627          fi
1628          fi
1629    fi
1630    if test ! "x$GSL" = x ; then
1631          echo "  Turning on use of GSL to control floating point calculations"
1632          echo "  Please make sure GSLINC, GSLLIB are defined"
1633          DEFINES="$DEFINES -DUSE_GSL_IEEE"
1634          INCLUDES="$INCLUDES $GSLINC"
1635          LIBS="$LIBS $GSLLIB"
1636    fi
1637    
1638  printf "\n===  Checking system libraries  ===\n"  printf "\n===  Checking system libraries  ===\n"
1639  printf "  Do we have the system() command using $FC...  "  printf "  Do we have the system() command using $FC...  "
1640  cat > genmake_tcomp.f <<EOF  cat > genmake_tcomp.$FS <<EOF
1641        program hello        program hello
1642        call system('echo hi')        call system('echo hi')
1643        end        end
1644  EOF  EOF
1645  $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.f > genmake_tcomp.log 2>&1  $FC $FFLAGS -o genmake_tcomp genmake_tcomp.$FS > genmake_tcomp.log 2>&1
1646  RETVAL=$?  RETVAL=$?
1647  if test "x$RETVAL" = x0 ; then  if test "x$RETVAL" = x0 ; then
1648      HAVE_SYSTEM=t      HAVE_SYSTEM=t
# Line 1304  fi Line 1655  fi
1655  rm -f genmake_tcomp*  rm -f genmake_tcomp*
1656    
1657  printf "  Do we have the fdate() command using $FC...  "  printf "  Do we have the fdate() command using $FC...  "
1658  cat > genmake_tcomp.f <<EOF  cat > genmake_tcomp.$FS <<EOF
1659        program hello        program hello
1660        CHARACTER(128) string        CHARACTER*(128) string
1661        string = ' '        string = ' '
1662        call fdate( string )        call fdate( string )
1663        print *, string        print *, string
1664        end        end
1665  EOF  EOF
1666  $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.f > genmake_tcomp.log 2>&1  $FC $FFLAGS -o genmake_tcomp genmake_tcomp.$FS > genmake_tcomp.log 2>&1
1667  RETVAL=$?  RETVAL=$?
1668  if test "x$RETVAL" = x0 ; then  if test "x$RETVAL" = x0 ; then
1669      HAVE_FDATE=t      HAVE_FDATE=t
# Line 1325  fi Line 1676  fi
1676  rm -f genmake_tcomp*  rm -f genmake_tcomp*
1677    
1678  printf "  Do we have the etime() command using $FC...  "  printf "  Do we have the etime() command using $FC...  "
1679  cat > genmake_tcomp.f <<EOF  cat > genmake_tcomp.$FS <<EOF
1680        program hello        program hello
1681        REAL*4 ACTUAL, TARRAY(2)        REAL*4 ACTUAL, TARRAY(2)
1682        EXTERNAL ETIME        EXTERNAL ETIME
# Line 1334  cat > genmake_tcomp.f <<EOF Line 1685  cat > genmake_tcomp.f <<EOF
1685        print *, tarray        print *, tarray
1686        end        end
1687  EOF  EOF
1688  $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.f > genmake_tcomp.log 2>&1  $FC $FFLAGS -o genmake_tcomp genmake_tcomp.$FS > genmake_tcomp.log 2>&1
1689  RETVAL=$?  RETVAL=$?
1690  if test "x$RETVAL" = x0 ; then  if test "x$RETVAL" = x0 ; then
1691      HAVE_ETIME=t      HAVE_ETIME=t
# Line 1352  if test "x$HAVE_CLOC" != x ; then Line 1703  if test "x$HAVE_CLOC" != x ; then
1703      echo "yes"      echo "yes"
1704  else  else
1705      echo "no"      echo "no"
1706        if test "x$EMBED_SRC" = xt ; then
1707            echo "    WARNING: you requested file embedding but it has"
1708            echo "      been disabled since C code cannot be called"
1709            EMBED_SRC=
1710        fi
1711    fi
1712    rm -f genmake_t*
1713    
1714    printf "  Can we unlimit the stack size using $FC...  "
1715    check_HAVE_SETRLSTK
1716    if test "x$HAVE_SETRLSTK" = xt ; then
1717        echo "yes"
1718    else
1719        echo "no"
1720    fi
1721    rm -f genmake_t*
1722    
1723    printf "  Can we register a signal handler using $FC...  "
1724    check_HAVE_SIGREG
1725    if test "x$HAVE_SIGREG" = xt ; then
1726        echo "yes"
1727    else
1728        echo "no"
1729  fi  fi
1730  rm -f genmake_t*  rm -f genmake_t*
1731    
# Line 1371  if test "x$HAVE_NETCDF" != x ; then Line 1745  if test "x$HAVE_NETCDF" != x ; then
1745  else  else
1746      echo "no"      echo "no"
1747  fi  fi
1748    DEFINES="$DEFINES $IGNORE_TIME"
1749    
1750    if test "x$EMBED_SRC" = xt ; then
1751        build_embed_encode
1752    fi
1753    if test "x$EMBED_SRC" = xt ; then
1754        ENABLE="$ENABLE embed_files"
1755    fi
1756    
1757    
1758  printf "\n===  Setting defaults  ===\n"  printf "\n===  Setting defaults  ===\n"
# Line 1388  for d in $MODS ; do Line 1770  for d in $MODS ; do
1770  done  done
1771  echo  echo
1772    
 if test "x$MAKEFILE" = x ; then  
     MAKEFILE="Makefile"  
 fi  
1773  if test "x${PLATFORM}" = x ; then  if test "x${PLATFORM}" = x ; then
1774      PLATFORM=$p_PLATFORM      PLATFORM=$p_PLATFORM
1775  fi  fi
# Line 1461  if test -r $ROOTDIR"/eesupp/src/Makefile Line 1840  if test -r $ROOTDIR"/eesupp/src/Makefile
1840      fi      fi
1841  fi  fi
1842    
1843  #same for exch2  #same for pkg/exch2 and pkg/regrid
1844  if test -r $ROOTDIR"/pkg/exch2/Makefile" ; then  for pdir in exch2 regrid ; do
1845      echo "  Making source files in exch2 from  templates"      if test -r $ROOTDIR"/pkg/${pdir}/Makefile" ; then
1846      ( cd $ROOTDIR"/pkg/exch2/" && $MAKE ) > make_exch2.errors 2>&1          echo "  Making source files in pkg/${pdir} from templates"
1847      RETVAL=$?          ( cd $ROOTDIR"/pkg/"${pdir} && $MAKE ) > make_${pdir}.errors 2>&1
1848      if test "x${RETVAL}" = x0 ; then          RETVAL=$?
1849          rm -f make_exch2.errors          if test "x${RETVAL}" = x0 ; then
1850      else              rm -f make_${pdir}.errors
1851          echo "Error: problem encountered while building source files in exch2:"          else
1852          cat make_exch2.errors 1>&2              echo "Error: problem encountered while building source files in pkg/${pdir}:"
1853          exit 1              cat make_${pdir}.errors 1>&2
1854                exit 1
1855            fi
1856      fi      fi
1857  fi  done
1858    
1859  printf "\n===  Determining package settings  ===\n"  printf "\n===  Determining package settings  ===\n"
1860  if  test "x${PDEPEND}" = x ; then  if  test "x${PDEPEND}" = x ; then
# Line 1584  done Line 1965  done
1965  rm -f ./.tmp_pack  rm -f ./.tmp_pack
1966  echo "    packages are:  $PACKAGES"  echo "    packages are:  $PACKAGES"
1967    
1968  #  Check availability of NetCDF and then either build the MNC template  #  Check for package MNC: if NetCDF is available, then build the MNC
1969  #  files or delete mnc from the list of available packages.  #  template files ; otherwise, delete mnc from the list of packages.
1970  echo $PACKAGES | grep ' mnc ' > /dev/null 2>&1  echo $PACKAGES | grep ' mnc ' > /dev/null 2>&1
1971  RETVAL=$?  RETVAL=$?
1972  if test "x$RETVAL" = x0 ; then  if test "x$RETVAL" = x0 ; then
# Line 1619  EOF Line 2000  EOF
2000      fi      fi
2001  fi  fi
2002    
2003    #  Check for package PROFILES: if NetCDF is not available,
2004    #  then delete profiles from the list of available packages.
2005    echo $PACKAGES | grep ' profiles ' > /dev/null 2>&1
2006    RETVAL=$?
2007    if test "x$RETVAL" = x0 ; then
2008        if test "x$HAVE_NETCDF" != xt ; then
2009            cat <<EOF
2010    
2011    *********************************************************************
2012    WARNING: the "profiles" package was enabled but tests failed to
2013      compile NetCDF applications.  Please check that:
2014    
2015      1) NetCDF is correctly installed for this compiler and
2016      2) the LIBS variable (within the "optfile") specifies the correct
2017           NetCDF library to link against.
2018    
2019      Due to this failure, the "profiles" package is now DISABLED.
2020    *********************************************************************
2021    
2022    EOF
2023            PACKAGES=`echo $PACKAGES | sed -e 's/profiles//g'`
2024            DISABLE="$DISABLE profiles"
2025        fi
2026    fi
2027    
2028  echo "  applying package dependency rules"  echo "  applying package dependency rules"
2029  ck=  ck=
2030  while test "x$ck" != xtt ; do  while test "x$ck" != xtt ; do
2031      i=0      i=0
2032      # rtot=${#PNAME[@]}      # rtot=${#PNAME[@]}
2033      rtot=$nname      rtot=$nname
2034      while test $i -lt $rtot ; do      while test $i -le $rtot ; do
2035    
2036          #  Is $pname in the current $PACKAGES list?          #  Is $pname in the current $PACKAGES list?
2037          #  pname=${PNAME[$i]}          #  pname=${PNAME[$i]}
# Line 1659  while test "x$ck" != xtt ; do Line 2065  while test "x$ck" != xtt ; do
2065    
2066          #  Do we need to add $dname according to the dependency rules?          #  Do we need to add $dname according to the dependency rules?
2067          if test "x$pin" = xt -a "x$plus" = "x+" -a "x$din" = xf ; then          if test "x$pin" = xt -a "x$plus" = "x+" -a "x$din" = xf ; then
2068                #echo "   " $pname ": need to add :" $dname
2069              in_dis="f"              in_dis="f"
2070              for dis in $DISABLE ; do              for dis in $DISABLE ; do
2071                  if test "x$dis" = "x$dname" ; then                  if test "x$dis" = "x$dname" ; then
# Line 1722  for n in $names ; do Line 2129  for n in $names ; do
2129              fi              fi
2130          done          done
2131          if test "x$has_pack" = xf ; then          if test "x$has_pack" = xf ; then
2132              undef=`echo "ALLOW_$n" | $AWK '{print toupper($0)}'`              undef=`echo "ALLOW_$n" | sed -e 'y/abcdefghijklmnopqrstuvwxyz/ABCDEFGHIJKLMNOPQRSTUVWXYZ/'`
2133              DISABLED_PACKAGES="$DISABLED_PACKAGES -U$undef"              DISABLED_PACKAGES="$DISABLED_PACKAGES -U$undef"
2134          fi          fi
2135      fi      fi
2136  done  done
2137  ENABLED_PACKAGES=  ENABLED_PACKAGES=
2138  for i in $PACKAGES ; do  for i in $PACKAGES ; do
2139      def=`echo "ALLOW_$i" | $AWK '{print toupper($0)}'`      def=`echo "ALLOW_$i" | sed -e 'y/abcdefghijklmnopqrstuvwxyz/ABCDEFGHIJKLMNOPQRSTUVWXYZ/'`
2140      ENABLED_PACKAGES="$ENABLED_PACKAGES -D$def"      ENABLED_PACKAGES="$ENABLED_PACKAGES -D$def"
2141  #eh3 DEFINES="$DEFINES -D$def"  #eh3 DEFINES="$DEFINES -D$def"
2142    
# Line 1813  for i in $SOURCEDIRS ; do Line 2220  for i in $SOURCEDIRS ; do
2220          cat $i/$j >> ad_files          cat $i/$j >> ad_files
2221      done      done
2222  done  done
2223    if test ! "x"$FS = "x.f" ; then
2224        cat ad_files | sed -e "s/\.f/.$FS/g" > ad_files_f
2225        mv -f ad_files_f ad_files
2226    fi
2227    
2228  echo  echo
2229  echo "===  Creating the Makefile  ==="  echo "===  Creating the Makefile  ==="
# Line 1824  for i in $INCLUDEDIRS ; do Line 2234  for i in $INCLUDEDIRS ; do
2234      fi      fi
2235  done  done
2236    
2237    if test ! "x$DIVA" = x ; then
2238        echo "  Creating the pseudo-MPI include directory"
2239        INCLUDES="-I./mpi_headers $INCLUDES"
2240        rm -rf ./mpi_headers
2241        mkdir -p ./mpi_headers
2242    
2243        if test "x$MPIINCLUDEDIR" = x ; then
2244            if test "x$MPIHOME" = x ; then
2245                MPIHOME='/usr'
2246            fi
2247            MPIINCLUDEDIR='$MPIHOME/include'
2248        fi
2249        
2250        if test -r $MPIINCLUDEDIR/mpif.h ; then
2251            for i in $MPI_HEADER_FILES; do
2252                cp -p $MPIINCLUDEDIR/$i ./mpi_headers
2253            done
2254    
2255            perl -i -pe 's/MPI_DISPLACEMENT_CURRENT=-1_8/MPI_DISPLACEMENT_CURRENT=-1/g' mpi_headers/mpif.h
2256        else
2257            echo " We cannot create a copy of mpif.h!"
2258    #       exit -1
2259        fi
2260    fi
2261    
2262  echo "  Determining the list of source and include files"  echo "  Determining the list of source and include files"
2263  rm -rf .links.tmp  rm -rf .links.tmp
2264  mkdir .links.tmp  mkdir .links.tmp
2265    touch .links.tmp/foo
2266    if test ! -r ".links.tmp/foo" ; then
2267        echo
2268        echo "ERROR : something is wrong with your directory permissions or"
2269        echo "   your user file-creation mask (\"umask\") since creating a"
2270        echo "   sub-dir, touch-ing a file within it, and then reading it is"
2271        echo "   not working.  Please try setting your umask to something"
2272        echo "   sane such as:"
2273        echo
2274        echo "      umask 0002"
2275        echo
2276        echo "   and please verify that you have the proper permissions for"
2277        echo "   creating sub-directories and then reading files created"
2278        echo "   within them."
2279        echo
2280        exit 1
2281    fi
2282    rm -f .links.tmp/foo
2283  echo "# This section creates symbolic links" > srclinks.tmp  echo "# This section creates symbolic links" > srclinks.tmp
2284  echo "" >> srclinks.tmp  echo "" >> srclinks.tmp
2285  printf 'SRCFILES = '    > srclist.inc  printf 'SRCFILES = '    > srclist.inc
# Line 1842  for d in $alldirs ; do Line 2295  for d in $alldirs ; do
2295      for sf in $sfiles ; do      for sf in $sfiles ; do
2296          if test ! -r ".links.tmp/$sf" ; then          if test ! -r ".links.tmp/$sf" ; then
2297              if test -f "$d/$sf" ; then              if test -f "$d/$sf" ; then
2298                    ignore_f=f
2299                  case $d/$sf in                  case $d/$sf in
2300                    ./$PACKAGES_DOT_H)                    ./$PACKAGES_DOT_H)
2301                            ignore_f=t
2302                          ;;                          ;;
2303                    ./AD_CONFIG.h)                    ./AD_CONFIG.h)
2304                            ignore_f=t
2305                          ;;                          ;;
2306                    ./FC_NAMEMANGLE.h)                    ./FC_NAMEMANGLE.h)
2307                            ignore_f=t
2308                          ;;                          ;;
2309                    ./BUILD_INFO.h)                    ./BUILD_INFO.h)
2310                            ignore_f=t
2311                            ;;
2312                      ./EMBEDDED_FILES.h)
2313                            ignore_f=t
2314                          ;;                          ;;
2315                    *)                    *)
2316                          touch .links.tmp/$sf                          #  For the local directory *ONLY*,
2317                          deplist="$deplist $sf"                          #  ignore all soft-links
2318                            if test "x$HAVE_TEST_L" = xt -a "x$d" = x. -a -L $sf ; then
2319                                ignore_f=t
2320                            else
2321                                touch .links.tmp/$sf
2322                                deplist="$deplist $sf"
2323                            fi
2324                          ;;                          ;;
2325                  esac                  esac
2326                  extn=`echo $sf | $AWK 'BEGIN {FS="."}; {print $NF}'`                  if test "x$ignore_f" = xf ; then
2327                  case $extn in                      extn=`echo $sf | $AWK -F. '{print $NF}'`
2328                      F)                      case $extn in
2329                          echo    " \\"  >> srclist.inc                          F)
2330                          printf " $sf" >> srclist.inc                              echo    " \\"  >> srclist.inc
2331                          ;;                              printf " $sf" >> srclist.inc
2332                      F90)                              ;;
2333                          echo    " \\"  >> f90srclist.inc                          F90)
2334                          printf " $sf" >> f90srclist.inc                              echo    " \\"  >> f90srclist.inc
2335                          ;;                              printf " $sf" >> f90srclist.inc
2336                      c)                              ;;
2337                          echo    " \\"  >> csrclist.inc                          c)
2338                          printf " $sf" >> csrclist.inc                              echo    " \\"  >> csrclist.inc
2339                          ;;                              printf " $sf" >> csrclist.inc
2340                      h)                              ;;
2341                          echo    " \\"  >> hlist.inc                          h)
2342                          printf " $sf" >> hlist.inc                              echo    " \\"  >> hlist.inc
2343                          ;;                              printf " $sf" >> hlist.inc
2344                      flow)                              ;;
2345                          echo    " \\"  >> ad_flow_files.inc                          flow)
2346                          printf " $sf" >> ad_flow_files.inc                              echo    " \\"  >> ad_flow_files.inc
2347                          ;;                              printf " $sf" >> ad_flow_files.inc
2348                  esac                              ;;
2349                        esac
2350                    fi
2351              fi              fi
2352          fi          fi
2353      done      done
# Line 1954  DISABLED_PACKAGES = ${DISABLED_PACKAGES} Line 2423  DISABLED_PACKAGES = ${DISABLED_PACKAGES}
2423    
2424  # These files are created by Makefile  # These files are created by Makefile
2425  SPECIAL_FILES = ${PACKAGES_DOT_H} AD_CONFIG.h FC_NAMEMANGLE.h BUILD_INFO.h  SPECIAL_FILES = ${PACKAGES_DOT_H} AD_CONFIG.h FC_NAMEMANGLE.h BUILD_INFO.h
   
2426  EOF  EOF
2427    
2428  #  Note: figure out some way to add Hyades JAM libraries here  if test "x$EMBED_SRC" = xt ; then
2429        echo "EMBEDDED_FILES = EMBEDDED_FILES.h" >>$MAKEFILE
2430    else
2431        echo "EMBEDDED_FILES = " >>$MAKEFILE
2432    fi
2433    
2434    #  Note: figure out some way to add Hyades JAM libraries here
2435  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
2436  # Unix ln (link)  # Unix ln (link)
2437  LN = ${LN}  LN = ${LN}
# Line 2009  cat hlist.inc         >> $MAKEFILE Line 2482  cat hlist.inc         >> $MAKEFILE
2482  cat ad_flow_files.inc >> $MAKEFILE  cat ad_flow_files.inc >> $MAKEFILE
2483  echo >> $MAKEFILE  echo >> $MAKEFILE
2484  echo 'F77FILES =  $(SRCFILES:.F=.'$FS')'      >> $MAKEFILE  echo 'F77FILES =  $(SRCFILES:.F=.'$FS')'      >> $MAKEFILE
2485  echo 'F90FILES =  $(F90SRCFILES:.F=.'$FS90')' >> $MAKEFILE  echo 'F90FILES =  $(F90SRCFILES:.F90=.'$FS90')' >> $MAKEFILE
2486  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE
2487  echo >> $MAKEFILE  echo >> $MAKEFILE
2488  echo '.SUFFIXES:' >> $MAKEFILE  echo '.SUFFIXES:' >> $MAKEFILE
# Line 2020  rm -f ad_flow_files.inc Line 2493  rm -f ad_flow_files.inc
2493  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
2494    
2495  all: \$(EXECUTABLE)  all: \$(EXECUTABLE)
2496  \$(EXECUTABLE): \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(OBJFILES)  \$(EXECUTABLE): \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(OBJFILES) \$(EMBEDDED_FILES)
2497          @echo Creating \$@ ...          @echo Creating \$@ ...
2498          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)
2499  depend:  depend:
# Line 2029  depend: Line 2502  depend:
2502          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)
2503          -rm -f makedepend.out          -rm -f makedepend.out
2504    
2505    lib: libmitgcmuv.a
2506    
2507    libmitgcmuv.a: \$(OBJFILES)
2508            ar rcv libmitgcmuv.a \$(OBJFILES)
2509            ar d   libmitgcmuv.a main.o
2510    
2511  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(SPECIAL_FILES)  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(SPECIAL_FILES)
2512    
2513  small_f: \$(F77FILES) \$(F90FILES)  small_f: \$(F77FILES) \$(F90FILES)
# Line 2038  output.txt: \$(EXECUTABLE) Line 2517  output.txt: \$(EXECUTABLE)
2517          @\$(EXECUTABLE) > \$@          @\$(EXECUTABLE) > \$@
2518    
2519  clean:  clean:
2520          -rm -rf *.o *.$FS *.p *.$FS90 *.mod ${RMFILES} work.{pc,pcl} *.template          -rm -rf *.p *.$FS90 *.mod ${RMFILES} work.{pc,pcl} *.template
2521            -rm -rf *.o
2522            -rm -rf *.$FS
2523  Clean:  Clean:
2524          @make clean          @make clean
2525          @make cleanlinks          @make cleanlinks
# Line 2049  CLEAN: Line 2530  CLEAN:
2530          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;
2531          -find \$(EXEDIR) -name "*.data" -exec rm {} \;          -find \$(EXEDIR) -name "*.data" -exec rm {} \;
2532          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;
2533          -rm -f \$(EXECUTABLE) output.txt STD*          -rm -f \$(EXECUTABLE) \$(EXE_AD) *.txt STD* *diagnostics.log datetime
2534            -rm -rf mnc_test_*
2535    
2536  #eh3 Makefile: makefile  #eh3 Makefile: makefile
2537  makefile:  makefile:
# Line 2077  test ! "x$THISUSER" = x && echo "      -echo Line 2559  test ! "x$THISUSER" = x && echo "      -echo
2559  test ! "x$THISDATE" = x && echo "       -echo \"#define THISDATE '$THISDATE'\" >> \$@" >> $MAKEFILE  test ! "x$THISDATE" = x && echo "       -echo \"#define THISDATE '$THISDATE'\" >> \$@" >> $MAKEFILE
2560  test ! "x$THISHOST" = x && echo "       -echo \"#define THISHOST '$THISHOST'\" >> \$@" >> $MAKEFILE  test ! "x$THISHOST" = x && echo "       -echo \"#define THISHOST '$THISHOST'\" >> \$@" >> $MAKEFILE
2561    
2562    if test "x$EMBED_SRC" = xt ; then
2563        cat >>$MAKEFILE <<EOF
2564    
2565    decode_files.o : EMBEDDED_FILES.h
2566    
2567    ##  \$(F77FILES)
2568    all_fF.tar.gz : \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(F77FILES) Makefile
2569            @echo Creating \$@ ...
2570            -tar -hcf all_fF.tar \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(F77FILES) Makefile
2571            -rm -f all_fF.tar.gz
2572            -gzip all_fF.tar
2573    
2574    EMBEDDED_FILES.h : all_fF.tar.gz
2575            @echo Creating \$@ ...
2576            -\${ROOTDIR}/tools/embed_encode/encode_files EMBEDDED_FILES.h all_fF.tar.gz
2577    
2578    EOF
2579    fi
2580    
2581  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
2582    
2583  # The normal chain of rules is (  .F - .$FS - .o  )  # The normal chain of rules is (  .F - .$FS - .o  )
# Line 2088  cat >>$MAKEFILE <<EOF Line 2589  cat >>$MAKEFILE <<EOF
2589          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
2590  .$FS.o:  .$FS.o:
2591          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<
2592  .F90.$FS90:  .F90.o:  
         \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@  
 .$FS90.o:  
2593          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<
2594  .c.o:  .c.o:
2595          \$(CC) \$(CFLAGS) -c \$<          \$(CC) \$(CFLAGS) \$(DEFINES) \$(INCLUDES) -c \$<
2596    
2597  # Special exceptions that use the ( .F - .p - .$FS - .o ) rule-chain  # Special exceptions that use the ( .F - .p - .$FS - .o ) rule-chain
2598  .F.p:  .F.p:
# Line 2117  ad_vars="$ad_vars FTL_TAMC_FLAGS FTL_TAF Line 2616  ad_vars="$ad_vars FTL_TAMC_FLAGS FTL_TAF
2616  ad_vars="$ad_vars SVD_TAMC_FLAGS SVD_TAF_FLAGS"  ad_vars="$ad_vars SVD_TAMC_FLAGS SVD_TAF_FLAGS"
2617  for i in $ad_vars ; do  for i in $ad_vars ; do
2618      name=$i      name=$i
2619      t1="t2=\$"`echo $i`      t1="t2=\$"`echo "$i"`
2620      eval $t1      eval $t1
2621      printf "%-20s = " $name >> $MAKEFILE      printf "%-20s = " $name >> $MAKEFILE
2622      echo $t2 >> $MAKEFILE      echo "$t2" | sed -e 's| \+| |g' >> $MAKEFILE
2623  done  done
2624    
2625  echo "  Add the source list for AD code generation"  echo "  Add the source list for AD code generation"
# Line 2137  rm -f ad_files Line 2636  rm -f ad_files
2636  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
2637    
2638  # ... AD ...  # ... AD ...
2639  adall: ad_taf  adall: \$(EXE_AD)
2640  adtaf: ad_taf_output.f  adtaf: ad_taf_output.$FS
2641  adtamc: ad_tamc_output.f  adtamc: ad_tamc_output.$FS
2642    
2643  ad_input_code.f: \$(AD_FILES) \$(HEADERFILES)  ad_input_code.$FS: \$(AD_FILES) \$(HEADERFILES)
2644          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -DALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ad_config.template          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -DALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ad_config.template
2645          cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h          cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h
2646          -rm -f ad_config.template          -rm -f ad_config.template
2647          @make \$(F77FILES)          @make \$(F77FILES)
2648          @make \$(AD_FLOW_FILES)          @make \$(AD_FLOW_FILES)
2649          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ad_input_code.f          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ad_input_code.$FS
2650    
2651  ad_taf_output.f: ad_input_code.f  ad_taf_output.$FS: ad_input_code.$FS
2652          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.$FS
2653          cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.f          cat ad_input_code_ad.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.$FS
2654    
2655  adtafonly:  adtafonly:
2656          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.$FS
2657          cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.f          cat ad_input_code_ad.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.$FS
2658    
2659  ad_taf: ad_taf_output.o \$(OBJFILES)  \${EXE_AD}: ad_taf_output.o \$(OBJFILES)
2660          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)          \$(LINK) -o \${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)
2661    
2662  ad_tamc_output.f: ad_input_code.f  ad_tamc_output.$FS: ad_input_code.$FS
2663          \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.f          \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.$FS
2664          cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_tamc_output.f          cat ad_input_code_ad.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ad_tamc_output.$FS
2665    
2666  ad_tamc: ad_tamc_output.o \$(OBJFILES)  ad_tamc: ad_tamc_output.o \$(OBJFILES)
2667          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_tamc_output.o \$(LIBS)          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_tamc_output.o \$(LIBS)
# Line 2175  adtrick: Line 2674  adtrick:
2674    
2675  # ... FTL ...  # ... FTL ...
2676  ftlall: ftl_taf  ftlall: ftl_taf
2677  ftltaf: ftl_taf_output.f  ftltaf: ftl_taf_output.$FS
2678  ftltamc: ftl_tamc_output.f  ftltamc: ftl_tamc_output.$FS
2679    
2680  ftl_input_code.f: \$(AD_FILES) \$(HEADERFILES)  ftl_input_code.$FS: \$(AD_FILES) \$(HEADERFILES)
2681          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template
2682          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h
2683          -rm -f ftl_config.template          -rm -f ftl_config.template
2684          @make \$(F77FILES)          @make \$(F77FILES)
2685          @make \$(AD_FLOW_FILES)          @make \$(AD_FLOW_FILES)
2686          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ftl_input_code.f          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ftl_input_code.$FS
2687    
2688  ftl_taf_output.f: ftl_input_code.f  ftl_taf_output.$FS: ftl_input_code.$FS
2689          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.f          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.$FS
2690          cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.f          cat ftl_input_code_ftl.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.$FS
2691    
2692  ftltafonly:  ftltafonly:
2693          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.f          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.$FS
2694          cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.f          cat ftl_input_code_ftl.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.$FS
2695    
2696  ftl_taf: ftl_taf_output.o \$(OBJFILES)  ftl_taf: ftl_taf_output.o \$(OBJFILES)
2697          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_taf_output.o \$(LIBS)          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_taf_output.o \$(LIBS)
2698    
2699  ftl_tamc_output.f: ftl_input_code.f  ftl_tamc_output.$FS: ftl_input_code.$FS
2700          \$(TAMC) \$(FTL_TAMC_FLAGS) \$(TAMC_EXTRA) ftl_input_code.f          \$(TAMC) \$(FTL_TAMC_FLAGS) \$(TAMC_EXTRA) ftl_input_code.$FS
2701          cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_tamc_output.f          cat ftl_input_code_ftl.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_tamc_output.$FS
2702    
2703  ftl_tamc: ftl_tamc_output.o \$(OBJFILES)  ftl_tamc: ftl_tamc_output.o \$(OBJFILES)
2704          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_tamc_output.o \$(LIBS)          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_tamc_output.o \$(LIBS)
2705    
2706    
2707  # ... SVD ...  # ... SVD ...
2708  svdtaf: ad_taf_output.f ftl_taf_output.f  svdtaf: ad_taf_output.$FS ftl_taf_output.$FS
2709          @echo "--->>> Only ran TAF to generate SVD code!    <<<---"          @echo "--->>> Only ran TAF to generate SVD code!    <<<---"
2710          @echo "--->>> Do make svdall afterwards to compile. <<<---"          @echo "--->>> Do make svdall afterwards to compile. <<<---"
2711  svdall: svd_touch svd_taf  svdall: svd_touch svd_taf
# Line 2222  svd_touch: Line 2721  svd_touch:
2721          @echo "--->>> Only COMPILE svd code! <<<---"          @echo "--->>> Only COMPILE svd code! <<<---"
2722          @echo "--->>> Assumes you previously <<<---"          @echo "--->>> Assumes you previously <<<---"
2723          @echo "--->>> did make svdtaf        <<<---"          @echo "--->>> did make svdtaf        <<<---"
2724          touch ad_taf_output.f ftl_taf_output.f          touch ad_taf_output.$FS ftl_taf_output.$FS
2725          \$(FC) \$(FFLAGS) \$(FOPTIM) -c ad_taf_output.f          \$(FC) \$(FFLAGS) \$(FOPTIM) -c ad_taf_output.$FS
2726          \$(FC) \$(FFLAGS) \$(FOPTIM) -c ftl_taf_output.f          \$(FC) \$(FFLAGS) \$(FOPTIM) -c ftl_taf_output.$FS
2727          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template
2728          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h
2729          -rm -f ftl_config.template          -rm -f ftl_config.template

Legend:
Removed from v.1.114  
changed lines
  Added in v.1.163

  ViewVC Help
Powered by ViewVC 1.1.22